## Lendo Arquivos
trapa <- read.table("trapa.csv", header=T,sep=",", , as.is=T,row.names=1)
trapa
class(trapa)
dim(trapa)
names(trapa)
rownames(trapa)
str(trapa)

### desconstruindo trapalhes 
trapa <- read.table("trapa.csv", header=T,sep=",", as.is=T)
trapa
str(trapa)
rownames(trapa)

### desconstruindo trapalhes 2
trapa <- read.table("trapa.csv", header=T,sep=",")
trapa
str(trapa)

### detonando os Trapalhes

trapa <- read.table("trapa.csv", header=T)
trapa
str(trapa)



### padro decimal com ","

trapa = read.table("trapaVirgula.csv", header=T, sep=",", as.is=T)
trapa
dim(trapa)
str(trapa)
trapa = read.table("trapaVirgula.csv", header=T, sep=";", as.is=T)
trapa
str(trapa)
mean(trapa$altura)
trapa = read.table("trapaVirgula.csv", header=T,dec=",", sep=";", as.is=T)
trapa
str(trapa)
mean(trapa$altura)

###padro ale

trapa.ale= read.table("trapa_nomes.txt", header=T, sep="/t", dec=., as.is=T)
dir()
choose.files()->caminho.file
caminho.file
trapa.ale= read.table(caminho.file, header=T, sep=\t", dec=., as.is=T)
trapa.ale<- read.table(caminho, header=T, sep="\t", as.is=T)
trapa.ale<- read.table("trapa_nome.txt", header=T, sep="\t", as.is=T)

##########  MANIPULANDO DADOS ######################

### Totais marginais, tapply

ilhas=matrix( round(sample(c(runif(36,0,6),rep(0,4)))),ncol=8)
colnames(ilhas)<-paste("ilha",1:8)
rownames(ilhas)<-paste("sp",1:5)
ilhas
ilhas.vf=ilhas>0
ilhas.vf
apply(ilhas.vf,1,sum)
apply(ilhas.vf,2,sum)
mean(apply(ilhas.vf,2,sum))
mean(apply(ilhas.vf,1,sum))


### Operadores Lgicos

ALTURA=c(1.85, 1.78, 1.92, 1.63, 1.81, 1.55)
ALTURA
SEXO=factor(rep(c("M","F"),each=3))
SEXO
ALTURA > 1.80
homens.altos <- ALTURA >= 1.80 & SEXO == "M"
homens.altos
class(homens.altos)
rank(ALTURA)
sort(ALTURA)
order(ALTURA)
ALTURA[order(ALTURA)]
ALTURA[c(6,4,2,5,1,3)]

#### INDEXAO "[]" ###########

x=(LETTERS[1:6])
x
x[1]
x[1:3]
x[c(1,1,3,5)]
x[-2]
x[-c(2,4)]

### INDEXAO COM LGICA #####

ALTURA
PESO=c(80, 100, 115,  70,  65,  50)
SEXO
ALTURA>=1.8
SEXO=="M"
homens.altos<-ALTURA>1.8 & SEXO=="M"
PESO[homens.altos]



### ALTERANDO SUCONJUNTOS ######

ilhas.vf
riqueza=apply(ilhas.vf,2,sum)
riqueza
riqueza.indice=order(riqueza,decreasing=T)
riqueza.indice
ilhas[,riqueza.indice]


read.table("trapa_nome.txt", header=T, sep="\t", as.is=T)->trapa
trapa
trapa[,1:5]
trapa$vivo=="s"
trapa[trapa$vivo=="s",]
trapa[which(trapa$vivo=="s"),]
trapa$vivo[which(trapa$vivo=="s")]<-T
trapa$vivo[which(trapa$vivo=="n")]<-F
trapa[,1:5]

                  #### TUTORIAL ###
caixeta=read.table("caixeta.csv", header=T, sep=",", as.is=T)
class(caixeta)
dim(caixeta)
names(caixeta)
str(caixeta)
head(caixeta)


### Transforme a coluna $especie em fator em um vetor separado

spp=factor(caixeta$especie)
spp

### Verifique o resultado do comando abaixo

unique(spp)

### Contando spp por local e selecionando uma localidade

str(caixeta)
caixeta.local = table(caixeta$especie, caixeta$local)
str(caixeta.local)
class(caixeta.local)
dimnames(caixeta.local)
caixeta.local[,"chauas"]

### transformando em matriz

caixeta.mat=matrix(caixeta.local,ncol=3)
colnames(caixeta.mat)<-colnames(caixeta.local)
rownames(caixeta.mat)<-rownames(caixeta.local)
caixeta.mat
str(caixeta.mat)
#faz diferena?
table(caixeta.local==caixeta.mat)



### totais marginais##
# nmero de espcies por local
caixeta.vf=caixeta.mat>0
caixeta.vf
riqueza=apply(caixeta.vf,2,sum)
riqueza


### Indexao e Manipulao
chauas = caixeta.mat[,"chauas"]
which(chauas>0)
chauas.bin <- chauas
chauas.bin[which(chauas>0)]<-1
chauas.bin

str(caixeta)
nome.spp <- unique(caixeta$especie)
nome.local <- unique(caixeta$local)
caixeta[caixeta$especie==nome.spp[1],]
caixeta[caixeta$local==nome.local[2],]
caixeta[caixeta$especie==nome.spp[1] & caixeta$local==nome.local[2],]

### Operaes Matriciais ###

##4.9.Operacao com matrizes
mat.trans <- matrix(c(0.43,0.33,0,0,0.61,0.3,0.56,0,0.96),3,3)
mat.trans
pop.inicio <- c(50,25,10)
names(pop.inicio)<-c("plntula", "jovem", "adulto")
pop.inicio
pop.1 <- m.trans%*%pop.inicio
pop.2 <- m.trans%*%pop.1
pop.3 <- m.trans%*%pop.2
pop.3
