## Ciclagem com vetores que so multiplos
## Veja que  feita a ciclagem mas nenhum aviso  dado!
a
b
a = 1:3
b = rep(1,9)
a*b

##Exemplo de tapply com dois fatores
## Criao dos dados
sexo = factor( rep(c("M","F"),each=10) )
cor.olhos = factor( c(rep(c("escuros","claro"),c(7,3)),rep(c("escuros","claro"),c(5,5)) ))
peso= c( rnorm(10, mean=80, sd=8), rnorm(10, mean=70, sd=8))
sexo
cor.olhos
peso
table(sexo,cor.olhos)
tapply(peso, list(sexo,cor.olhos), mean)

## Distribuio binomial: exemplo do Fazendeiro com 12 filhas
## Probabilidade de 0 a 12 sucessos, em 12 tentativas
## dada probabilidade de 0.5 para cada sucesso
probs= dbinom (0:12, size=12, prob=0.5)
## Acrescentando um nome para cada elemento do objeto criado acima
names(probs) = 0:12
## Exibir estes valores com cinco casas decimais
round(probs, 5)
## Grafico
plot(0:12, probs, type= "h", lwd=3, xlab="N de meninos", ylab="Probabilidade")
## Qual a probabilidade de no ter meninos?
dbinom(0, size=12, prob=0.5)
## Adicionando isto ao grafico
points(0,dbinom(0, size=12, prob=0.5), col="red", type="h", lwd=4)
## Qual a probabilidade de  ter pelos menos um menino?
## no grafico
points(1:12,dbinom(1:12, size=12, prob=0.5), col="red", type="h", lwd=8)
## Esta probabilidade  a soma das probabilidades para 1 a 12 meninos:
## usando indexao (veremos isto na aula  de amanh)
probs[2:13]
sum(probs[2:13])
## Ou usando a funcao de probabilidade do R
pbinom(0, size=12, prob=0.5, lower.tail = F)
## E Se a probabibilidade de um menino fosse de 1/3?
probs.2= dbinom (0:12, size=12, prob=1/3)
## Compare com o grafico anterior:
plot(0:12, probs.2, type= "h", lwd=3, xlab="N de meninos", ylab="Probabilidade")
## Simulando numeros de meninos em 10 familias de 12 filhos cada
rbinom(10, size=12, prob=0.5)


## Grafico da normal com diferentes parametros (m = mdia e d = desvio-padro)
## Exemplo das larguras de quadris da populacao dos EUA
## A funcao curve traca curva de uma funcao. Comparametro add=T acrescenta estas curvas ao grafico ativo
## Para entender veja a ajuda da funcao e aguarde a aula sobre graficos
curve(dnorm(x,mean=14.4,sd=1),8,26, col="red", xlab="Largura (in)", ylab="Densidade Probabilstica")
curve(dnorm(x,mean=14.4,sd=2),add=T, col="blue")
curve(dnorm(x,mean=18,sd=2),add=T, col="green")
legend(17, 0.4, legend=c("m=14.4,d=1","m=14.4,d=2","m=18,d=2"), col=c("red", "blue","green"), lty=1)



