#### Tutorial - Introduo ao R - Monitoria 2010

########## ############### #############

getwd()
setwd("C:/Users/Barbara/Documents/Mestrado/Monitoria/letras")

#########   A Melhor Maneira de Executar o R no Windows	##########

load("letras.rdata")   #### carregando arquivo no workspace
ls()			     #### vendo oq tem no workspace
save.image ()	     #### salvando workspace

pares <- c(2,4,6,8)		#### criando novos objetos
impares <- c(1,3,5,7,9)
todos.os.numeros <- c(pares,impares)


#########	Criando Objetos	##########

a <- 1
b <- a

b <- a <- 2

a = 3 -> b

#########	Listando e Removendo Objetos	#########

A1 <- c(1,2,3)
A2 <- c(10,20,30)
b <- c(A1,A2)
ls()

help(ls)

a.1 <- A1   #### cria novos objetos com mm contedo, mas nome diferente
a.2 <- A2
ls()
rm( list=c("A1","A2") )	#### remove os objetos que no quer mais
ls()

##ou
rm(list=ls(pattern="A"))
ls()

##ou
rm(A1,A2)

#########	Classes de Objetos e Coero	############

copa.70 <- "21/07/70"
copa.94 <- "17/07/94" 

copa.94 - copa.70	#### erro: argumento no numrico

copa.70 <- as.Date(copa.70,format="%d/%m/%y") 	#### transforma dados na classe "data"
copa.94 <- as.Date(copa.94,format="%d/%m/%y")
class(copa.70)
class(copa.94)
copa.94 - copa.70	#### cculo possvel

########	Nveis de Fatores	#########

herb <- c("A","M","M","A","A","M","M","B","A","A","A","A","B","A")  ### dados

herb.f <- factor(herb)	#### transformao dos dados em fatores

herb.t <- table(herb.f) #### conta n de obs em cd nvel de fator
herb.t

plot(herb.t)

herb.f <- factor(herb, levels=c("N","B","M","A"))  ### ordena fatores conforme interesse
herb.t <- table(herb.f)
herb.t
plot(herb.t)

##########	Carregando Pacotes	###########

library()   ##### verifica pacotes disponveis na sua instalao do R

help.start()	#### interface de hipertexto - help para ver pacotes tb

search()   #### ver quais pacotes esto carregados

x1 <- rnorm(n=15, mean=1, sd=3)   ### cria 15 ns com distrib normal, mdia 1 e desvio padro 3

hist(x1)

truehist(x1)   ##### erro: pacote no est instalado

search()
library(MASS)	#### instala o pacote
search()
truehist(x1)	###### agora  executvel








